local GetSendMailItem, SendMail, SendMailNameEditBox, SendMailScrollChildFrame, SendMailSubjectEditBox, idTweaks, idTweaksModule, idTweaksOptions, Option, ToggleOption, Mail
do
  local _obj_0 = _G
  GetSendMailItem, SendMail, SendMailNameEditBox, SendMailScrollChildFrame, SendMailSubjectEditBox, idTweaks, idTweaksModule, idTweaksOptions = _obj_0.GetSendMailItem, _obj_0.SendMail, _obj_0.SendMailNameEditBox, _obj_0.SendMailScrollChildFrame, _obj_0.SendMailSubjectEditBox, _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaksOptions
  Option, ToggleOption = _obj_0.Option, _obj_0.ToggleOption
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      return self.options:add_option(ToggleOption(self, "auto_send_mail", "Auto Send", "When the mail has a Recipient and all item slots are filled, send it."))
    end,
    enable = function(self)
      return self.ace_module:RegisterEvent("MAIL_SEND_INFO_UPDATE", function(...)
        if not (self.db.auto_send_mail) then
          return 
        end
        if self:can_send_mail() then
          return self:send_mail()
        end
      end)
    end,
    disable = function(self)
      return self.ace_module:UnregisterEvent("MAIL_SEND_INFO_UPDATE")
    end,
    get_free_mail_slots = function(self)
      local freeSlots = 0
      for slot = 1, 12 do
        local itemName, _
        itemName, _, _, _ = GetSendMailItem(slot)
        if not itemName then
          freeSlots = freeSlots + 1
        end
      end
      return freeSlots
    end,
    is_mail_full = function(self)
      return self:get_free_mail_slots() == 0
    end,
    get_mail_recipient = function(self)
      return SendMailNameEditBox:GetText()
    end,
    set_mail_recipient = function(self, recipient)
      return SendMailNameEditBox:SetText(recipient)
    end,
    mail_has_recipient = function(self)
      return self:get_mail_recipient() ~= ""
    end,
    get_mail_subject = function(self)
      return SendMailSubjectEditBox:GetText()
    end,
    mail_has_subject = function(self)
      return self:get_mail_subject() ~= ""
    end,
    get_mail_body = function(self)
      return SendMailScrollChildFrame:GetText()
    end,
    can_send_mail = function(self)
      return self:mail_has_recipient() and self:mail_has_subject() and self:is_mail_full()
    end,
    send_mail = function(self)
      local recipient = self:get_mail_recipient()
      local subject = self:get_mail_subject()
      SendMail(recipient, subject, "")
      return self:set_mail_recipient(recipient)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      return _class_0.__parent.__init(self, addon, "Mail", "AceConsole-3.0", "AceEvent-3.0")
    end,
    __base = _base_0,
    __name = "Mail",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Mail = _class_0
end
return idTweaks:add_module(Mail(idTweaks))
